package com.outerboxcloud.outerboxtsc;

import android.os.StrictMode;

import androidx.annotation.NonNull;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

import com.example.tscdll.TscWifiActivity;

/** OuterboxtscPlugin */
public class OuterboxtscPlugin implements FlutterPlugin, MethodCallHandler {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity

  TscWifiActivity tscEthernetRunner = new TscWifiActivity();


  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    StrictMode.setThreadPolicy(new StrictMode.ThreadPolicy.Builder()
            .detectDiskReads()
            .detectDiskWrites()
            .detectNetwork()   // or .detectAll() for all detectable problems
            .penaltyLog()
            .build());
    StrictMode.setVmPolicy(new StrictMode.VmPolicy.Builder()
            .detectLeakedSqlLiteObjects()
            .detectLeakedClosableObjects()
            .penaltyLog()
            .penaltyDeath()
            .build());
    final MethodChannel channel = new MethodChannel(flutterPluginBinding.getFlutterEngine().getDartExecutor(), "outerboxtsc");
    channel.setMethodCallHandler(new OuterboxtscPlugin());
  }

  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "outerboxtsc");
    channel.setMethodCallHandler(new OuterboxtscPlugin());
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("sticker")) {
      String ipAddress = call.argument("ipAddress");
      String lot = call.argument("lot");
      String product = call.argument("product");
      String number = call.argument("number");
      String currentDate = call.argument("currentDate");

      tscEthernetRunner.openport(ipAddress,9100, 0);
      tscEthernetRunner.setup(58, 41, 4, 1, 0, 3, 0);
      tscEthernetRunner.clearbuffer();

      tscEthernetRunner.printerfont(150, 0, "4", 0, 1, 1, "Outerbox");
      tscEthernetRunner.printerfont(14, 80, "2", 0, 1, 1, product);
      tscEthernetRunner.printerfont(328, 180, "2", 0, 1, 1, currentDate);
      tscEthernetRunner.printerfont(14, 200, "2", 0, 1, 1, number);
      tscEthernetRunner.printlabel(1, 1);

//      tscEthernetRunner.printerfont(150, 4, "4", 0, 1, 1, "Outerbox");
//      tscEthernetRunner.printerfont(14, 80, "2", 0, 1, 1, product);
//      tscEthernetRunner.printerfont(328, 256, "2", 0, 1, 1, currentDate);
//      tscEthernetRunner.printerfont(14, 200, "2", 0, 1, 1, number);
//      tscEthernetRunner.printlabel(1, 1);
      tscEthernetRunner.closeport();
      result.success("Success Printing");
    } else {
      result.notImplemented();
    }
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    //channel.setMethodCallHandler(null);
  }
}
